( function() {
    function copyToClipboard( value ) {
        var input = document.createElement( 'textarea' );
        document.getElementsByTagName( 'body' )[0].appendChild( input );
        input.value = value;
        input.select();
        document.execCommand( 'copy' );
        input.remove();
    }

    function handleResponse( response ) {
        const status = document.getElementById( 'extensionStatus' );
        if ( status ) {
            if ( response && response.linked ) {
                status.className = 'task is-linked';
            } else if ( response ) {
                status.className = 'task is-notlinked';
            }
            status.querySelector( '.when-linked a' ).addEventListener( 'click', function() {
                chrome.runtime.sendMessage( {
                    type: 'unlink',
                    issuer: meta.getAttribute( "content" )
                }, function( response ) {
                    status.className = 'task is-notlinked';
                } );
            } );
            status.querySelector( '.when-notlinked a' ).addEventListener( 'click', function() {
                chrome.runtime.sendMessage( {
                    type: 'link',
                    issuer: meta.getAttribute( "content" )
                }, function( response ) {
                    status.className = 'task is-linked';
                } );
            } );
        }
        if ( response && response.linked ) {
            document.body.setAttribute( 'keyhub-extension-linked', true );

            window.addEventListener( "message", function( event ) {
                // We only accept messages from ourselves
                if ( event.source != window )
                    return;

                if ( event.data.type === "copy-to-clipboard" ) {
                    copyToClipboard( event.data.value );
                }
            }, false );
        }
    }

    const meta = document.querySelector( "meta[name='keyhub-issuer']" );
    if ( meta ) {
        const msg = {
            type: 'query',
            issuer: meta.getAttribute( "content" )
        };
        chrome.runtime.sendMessage( msg, handleResponse );
    }
} )();